config/routes.rb
Depot::Application.routes.draw do
  get "admin" => "admin#index"
  controller :sessions do
    get 'login' => :new
    post 'login' => :create
    get 'logout' => :destroy
  end
  resources :users

  resources :products do
    get :who_bought, on: :member
  end

  scope '(:locale)' do
  	resources :line_items
  	get "line_items/decrease/:id" => "line_items#decrease", as: :line_items_decrease
  	resources :carts
  	resources :orders
  	get "orders/ship/:id" => "orders#ship", as: :ship_order
  	root 'store#index', as: 'store', via: :all
  end

  

end

app/models/order.rb
class Order < ActiveRecord::Base
    has_many :line_items, dependent: :destroy
    belongs_to :pay_type

    #PAYMENT_TYPES = ["Check", "Credit Cart", "Purchase Order"]

    validates :name, :address, :email,  presence: true
    #validates :pay_type, inclusion: PAYMENT_TYPES

    def add_line_items_from_cart(cart)
           cart.line_items.each do |item|
               item.cart_id = nil
               line_items << item
           end
    end
end

app/controllers/orders_controller.rb
class EmailAddressError < Exception
end

class OrdersController < ApplicationController
  include CurrentCart
  before_action :set_cart, only: [:new, :create]
  before_action :set_order, only: [:show, :edit, :update, :destroy, :ship, :email_notification_error]
  rescue_from EmailAddressError, with: :email_notification_error
  skip_before_action :authorize, only: [:new, :create]

  # GET /orders
  # GET /orders.json
  def index
    @orders = Order.all
  end

  # GET /orders/1
  # GET /orders/1.json
  def show
  end

  def ship
    @order.ship_date = Time.now
    @order.save!
    if @order.email.match /^\w+([-\+.\w]+)*@\w+*([\.\w]+*)$/
        OrderNotifier.shipped(@order).deliver
    else
        raise EmailAddressError
    end
    redirect_to orders_url, notice: "Order #{@order.id} is shipped." 
  end

  # GET /orders/new
  def new
    if @cart.line_items.empty?
        redirect_to store_url, notice: I18n.t('.cart_is_empty')
        return
    end

    @checkout_page = true
    @order = Order.new
  end

  # GET /orders/1/edit
  def edit
  end

  # POST /orders
  # POST /orders.json
  def create
    if @cart.line_items.empty?
        redirect_to store_url, notice: I18n.t('.cart_is_empty') 
        return
    end

    @order = Order.new(order_params)
    @order.add_line_items_from_cart @cart

    respond_to do |format|
      if @order.save
        Cart.destroy session[:cart_id]
        session[:cart_id] = nil
        if @order.email.match /^\w+([-\+.\w]+)*@\w+*([\.\w]+*)$/
            OrderNotifier.received(@order).deliver
        else
            raise EmailAddressError
        end

        format.html { redirect_to store_url, notice: I18n.t('.create_order_thanks') }
        format.json { render action: 'show', status: :created, location: @order }
      else
        format.html { render action: 'new' }
        format.json { render json: @order.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /orders/1
  # PATCH/PUT /orders/1.json
  def update
    respond_to do |format|
      if @order.update(order_params)
        format.html { redirect_to @order, notice: 'Order was successfully updated.' }
        format.json { head :no_content }
      else
        format.html { render action: 'edit' }
        format.json { render json: @order.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /orders/1
  # DELETE /orders/1.json
  def destroy
    @order.destroy
    respond_to do |format|
      format.html { redirect_to orders_url }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_order
      @order = Order.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def order_params
      params.require(:order).permit(:name, :address, :email, :pay_type_id)
    end

    def email_notification_error
        OrderNotifier.notify_admin_email_error(@order).deliver
        redirect_to store_url, notice: 'Failed to send order confirmation email'
    end
end

app/helpers/orders_helper.rb
module OrdersHelper
end

app/views/orders/_form.html.erb
<%= form_for(@order) do |f| %>
  <% if @order.errors.any? %>
    <div id="error_explanation">
      <h2><%= raw t('errors.template.header', count: @order.errors.count, model: t('activerecord.models.order')) %>:</h2>
      <p><%= t('errors.template.body') %></p>

      <ul>
      <% @order.errors.full_messages.each do |msg| %>
        <li><%= raw msg %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name, t('.name') %><br>
    <%= f.text_field :name, size: 40 %>
  </div>
  <div class="field">
    <%= f.label :address, t('.address_html') %><br>
    <%= f.text_area :address, rows: 3, cols: 40 %>
  </div>
  <div class="field">
    <%= f.label :email, t('.email') %><br>
    <%= f.text_field :email, size: 40 %>
  </div>
  <div class="field">
    <%= f.label :pay_type_id, t('.pay_type') %><br>
    <%= collection_select(:order, :pay_type_id, PayType.all, :id, :name_localize) %>
  </div>
  <div class="actions">
    <%= f.submit t('.submit') %>
  </div>
<% end %>

app/views/orders/edit.html.erb
<h1>Editing order</h1>

<%= render 'form' %>

<%= link_to 'Show', @order %> |
<%= link_to 'Back', orders_path %>

app/views/orders/index.html.erb
<h1>Listing orders</h1>
<% if notice %>
    <p id="notice"><%= notice%></p>
<% end %>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th>Address</th>
      <th>Email</th>
      <th>Pay type</th>
      <th></th>
      <th></th>
      <th></th>
    </tr>
  </thead>

  <tbody>
    <% @orders.each do |order| %>
      <tr>
        <td><%= order.name %></td>
        <td><%= order.address %></td>
        <td><%= order.email %></td>
        <td><%= order.pay_type.name %></td>
        <td><%= link_to 'Show', order %></td>
        <% if order.ship_date.nil?%>
            <td><%= link_to 'Ship', ship_order_path(order) %></td>
        <% else %>
            <td><%= 'Shipped'%></td>
        <% end %>
        <td><%= link_to 'Edit', edit_order_path(order) %></td>
        <td><%= link_to 'Destroy', order, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Order', new_order_path %>

app/views/orders/new.html.erb
<div class="depot_form">
    <fieldset>
        <legend><%= t('.legend') %></legend>
        <%= render 'form' %>
    </fieldset>
</div>

app/views/orders/show.html.erb
<% if notice%>
  <p id="notice"><%= notice %></p>
<% end %>

<p>
  <strong>Name:</strong>
  <%= @order.name %>
</p>

<p>
  <strong>Address:</strong>
  <%= @order.address %>
</p>

<p>
  <strong>Email:</strong>
  <%= @order.email %>
</p>

<p>
  <strong>Pay type:</strong>
  <%= @order.pay_type.name %>
</p>

<%= link_to 'Edit', edit_order_path(@order) %> |
<%= link_to 'Back', orders_path %>